/* PenPen Viewer Java (JavaScript) *//*

2003-04-16 orca
  SVGłƂč, PenPenȂ AWT/Swingłł邩,
  }쐬B
*/
importPackage(java.lang, java.awt)
//importClass(java.awt.BasicStroke)

if (arguments.length == 0) {
  print('t@Cw肵ĉ')
  quit()
}
var pdbname = arguments[0]

load('PalmPDB.js')

ndb = new PalmPDB(pdbname)
if (ndb.typeid == idvalue('Data')) print('OK')   // ̂ƂӖȂ

/**
 * PenPenp PDB\f[^ (PenNDB, PenXDB)
 * 2ނ PDB, f[^ځBO͓KɌ߂́B
 */
var o1 = { headersize: 13, _01_size:  0, framesize: 3200, linesize: 4, framecount: 4, _02_size: 3 }
var o2 = { headersize: 13, _01_size: 68, framesize: 7200, linesize: 6, framecount: 4, _02_size: 3 }
var tblPenPen = []
tblPenPen[idvalue('PenN')] = o1
tblPenPen[idvalue('PenX')] = o2

ppInfo = tblPenPen[ndb.creatorid]   // global


/**
 * Byte Array𐔒lɕϊ
 *
 * @param ba:byte[]   bynary data
 * @param st:Number   ϊJnʒu (0;擪)
 * @param ln:Number   ϊ钷
 * @return :Number   ϊ
 */
function baToNumber(ba, st, ln) {
  var res = 0

  if (arguments.length == 1) {
    st = 0
    ln = ba.length
  }
  if (arguments.length == 2) {
    ln = st
    st = 0
  }

  for (var i = 0; i < ln; i++) {
    var b = ba[st +i]
    res <<= 8;
    res += b >= 0? b: 256 +b
  }

  return res
}


/**
 * Canvasɒǉuc
 */
var o = {
  px1: null,
  py1: null,
  px2: null,
  py2: null,
  lineColor: null,
  lineType: null,

  paint: function (g) {
    if (this.px1)
      for (var i = 0; i < this.px1.length; i++) {
        g.setColor(this.lineColor[i])
        g.drawLine(this.px1[i], this.py1[i], this.px2[i], this.py2[i])
      }
  }
}

/**
 * PenPen PDB, w肳ꂽʂ̃f[^o
 * tB[hɃZbgB
 *
 * @param cv:Canvas   `Ƃ
 * @param rno:Number   R[hԍ (0 -)
 * @param frm:Number   t[ԍ (0 - 3)
 */
function loadData(cv, rno, frm) {
  var ba = ndb.records[rno]
  var pHead = ppInfo.headersize +ppInfo._01_size
  var vCnt = baToNumber(ba,
      pHead +ppInfo.framesize *ppInfo.framecount +ppInfo._02_size +4 *frm, 4)

  var p = pHead +ppInfo.framesize *frm
  var limit = p +Math.min(ppInfo.framesize, vCnt *ppInfo.linesize)

  var byteToNum = function (b) { return b >= 0? b: 256 +b }

  cv.px1 = []
  cv.py1 = []
  cv.px2 = []
  cv.py2 = []
  cv.lineColor = []
  cv.lineType = []

  for (var i = 0; p < limit; i++, p += ppInfo.linesize) {
    var pp = p +ppInfo.linesize
    var col = ppInfo.linesize > 4? byteToNum(ba[p]): 0x0000ff

    cv.px1[i] = byteToNum(ba[pp -4])
    cv.py1[i] = byteToNum(ba[pp -3])
    cv.px2[i] = byteToNum(ba[pp -2])
    cv.py2[i] = byteToNum(ba[pp -1])
    cv.lineColor[i] = new Color(col)
  }
}

/**
 * R|[lg̐
 *
 * @return :Component   R|[lg
 */
function createComponents() {
  var panel = new Panel(new BorderLayout())
  var canvas = new JavaAdapter(Canvas, o)

  loadData(canvas, 2, 0)
  canvas.setSize(260, 260)
  panel.add(canvas, BorderLayout.CENTER)

  return panel
}

/**
 * Main
 */
var f = new Frame('PenPen Viewer (AWT)')
f.add(createComponents())

f.addWindowListener(
  new java.awt.event.WindowAdapter() {
    windowClosing: function (event) {
      print('quit')
      quit()
    }
  }
)

f.pack()
f.setVisible(true)

/* -- End of Script -- */
